# -> Reset player score
scoreboard players set @s CM_UsedBow 0

# -> Get nearby arrows' UUID
execute as @e[type=#minecraft:arrows,distance=..8] run function classic_mechanics:mechanics_modules/old_projectile_motion/get_uuid

# -> Get player's UUID & tag them
function classic_mechanics:mechanics_modules/old_projectile_motion/get_uuid
tag @s add CM.ThrowingPlayer

# -> Tag thrown projectiles
execute as @e[type=#arrows,distance=..8,nbt={player:1b,life:0s}] if score @s CM_ProjID1 = @p[tag=CM.ThrowingPlayer] CM_ProjID1 if score @s CM_ProjID2 = @p[tag=CM.ThrowingPlayer] CM_ProjID2 if score @s CM_ProjID3 = @p[tag=CM.ThrowingPlayer] CM_ProjID3 if score @s CM_ProjID4 = @p[tag=CM.ThrowingPlayer] CM_ProjID4 run tag @s add CM.ThrownProjectile

# -> Find arrow type
execute anchored eyes positioned ^ ^ ^0.1 as @n[type=#arrows,tag=CM.ThrownProjectile] if entity @s[type=arrow] run scoreboard players set @p[tag=CM.ThrowingPlayer] CM_ThrownArrowType 1
execute anchored eyes positioned ^ ^ ^0.1 as @n[type=#arrows,tag=CM.ThrownProjectile] if entity @s[type=spectral_arrow] run scoreboard players set @p[tag=CM.ThrowingPlayer] CM_ThrownArrowType 2

# -> Summon arrow
execute anchored eyes run summon arrow ^ ^ ^0.1 {HasVisualFire:1b,Tags:["CM.ThrownArrow","CM.TempThrownProj","CM.OldThrownProjectile"]}

# -> Copy NBT of vanilla arrow into new arrow
data modify entity @n[type=#arrows,tag=CM.TempThrownProj] item set from entity @n[type=#arrows,tag=CM.ThrownProjectile] item
data modify entity @n[type=#arrows,tag=CM.TempThrownProj] pickup set from entity @n[type=#arrows,tag=CM.ThrownProjectile] pickup
data modify entity @n[type=#arrows,tag=CM.TempThrownProj] damage set from entity @n[type=#arrows,tag=CM.ThrownProjectile] damage
data modify entity @n[type=#arrows,tag=CM.TempThrownProj] crit set from entity @n[type=#arrows,tag=CM.ThrownProjectile] crit
data modify entity @n[type=#arrows,tag=CM.TempThrownProj] Rotation set from entity @n[type=#arrows,tag=CM.ThrownProjectile] Rotation

# -> Remove vanilla thrown arrow
execute anchored eyes positioned ^ ^ ^0.1 as @n[type=#arrows,tag=CM.ThrownProjectile] run kill @s

# -> Store player UUID into arrow owner NBT
data modify entity @n[type=arrow,tag=CM.TempThrownProj] Owner set from entity @s UUID

# -> Get projectile position 1 (start)
execute as @n[type=#arrows,tag=CM.TempThrownProj] at @s store result score @s CM_ProjStartX run data get entity @s Pos[0] 1000
execute as @n[type=#arrows,tag=CM.TempThrownProj] at @s store result score @s CM_ProjStartY run data get entity @s Pos[1] 1000
execute as @n[type=#arrows,tag=CM.TempThrownProj] at @s store result score @s CM_ProjStartZ run data get entity @s Pos[2] 1000

# -> Teleport to end position
execute anchored eyes run tp @n[type=arrow,tag=CM.TempThrownProj] ^ ^ ^0.5

# -> Get projectile position 2 (end)
execute as @n[type=#arrows,tag=CM.TempThrownProj] at @s store result score @s CM_ProjEndX run data get entity @s Pos[0] 1000
execute as @n[type=#arrows,tag=CM.TempThrownProj] at @s store result score @s CM_ProjEndY run data get entity @s Pos[1] 1000
execute as @n[type=#arrows,tag=CM.TempThrownProj] at @s store result score @s CM_ProjEndZ run data get entity @s Pos[2] 1000

# -> Subtract end position from starting position
execute as @n[type=#arrows,tag=CM.TempThrownProj] run scoreboard players operation @s CM_ProjEndX -= @s CM_ProjStartX
execute as @n[type=#arrows,tag=CM.TempThrownProj] run scoreboard players operation @s CM_ProjEndY -= @s CM_ProjStartY
execute as @n[type=#arrows,tag=CM.TempThrownProj] run scoreboard players operation @s CM_ProjEndZ -= @s CM_ProjStartZ

# -> Teleport back to starting position
execute anchored eyes run tp @n[type=#arrows,tag=CM.TempThrownProj] ^ ^ ^0.1

# -> Apply motion to projectile
execute as @n[type=#arrows,tag=CM.TempThrownProj] store result entity @s Motion[0] double 0.00341 run scoreboard players get @s CM_ProjEndX
execute as @n[type=#arrows,tag=CM.TempThrownProj] store result entity @s Motion[1] double 0.00341 run scoreboard players get @s CM_ProjEndY
execute as @n[type=#arrows,tag=CM.TempThrownProj] store result entity @s Motion[2] double 0.00341 run scoreboard players get @s CM_ProjEndZ

# -> Untag all
tag @n[type=#arrows,tag=CM.TempThrownProj] remove CM.TempThrownProj
tag @s remove CM.ThrowingPlayer